package cn.com.infosec.util.base64;

import java.io.InputStream;
import java.io.OutputStream;

public class MyBASE64Decoder extends MyCharacterDecoder {
   private static final char[] pem_array = new char[]{'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/'};
   private static final byte[] pem_convert_array = new byte[256];
   byte[] decode_buffer = new byte[4];

   static {
      int var0;
      for(var0 = 0; var0 < 255; ++var0) {
         pem_convert_array[var0] = -1;
      }

      char[] var1;
      for(var0 = 0; var0 < (var1 = pem_array).length; ++var0) {
         char var2 = var1[var0];
         pem_convert_array[var2] = (byte)var0;
      }

   }

   protected int bytesPerAtom() {
      return 4;
   }

   protected int bytesPerLine() {
      return 72;
   }

   protected void decodeAtom(InputStream inputstream, OutputStream outputstream, int i) {
      byte var4 = -1;
      byte var5 = -1;
      byte var6 = -1;
      byte var7 = -1;
      if (i < 2) {
         throw new FormatException("BASE64Decoder: Not enough bytes for an atom.");
      } else {
         int var8;
         do {
            if ((var8 = inputstream.read()) == -1) {
               throw new StreamExhausted();
            }
         } while(var8 == 10 || var8 == 13);

         InputStream var10001 = inputstream;
         byte[] inputstream1;
         (inputstream1 = this.decode_buffer)[0] = (byte)var8;
         var8 = i - 1;
         if (this.readFully(var10001, inputstream1, 1, var8) == -1) {
            throw new StreamExhausted();
         } else {
            if (i > 3 && this.decode_buffer[3] == 61) {
               i = 3;
            }

            if (i > 2 && this.decode_buffer[2] == 61) {
               i = 2;
            }

            label49: {
               if (i != 2) {
                  if (i != 3) {
                     if (i != 4) {
                        break label49;
                     }

                     var7 = pem_convert_array[this.decode_buffer[3] & 255];
                  }

                  var6 = pem_convert_array[this.decode_buffer[2] & 255];
               }

               byte[] var10000 = inputstream1 = pem_convert_array;
               byte[] var10 = this.decode_buffer;
               var5 = inputstream1[var10[1] & 255];
               var4 = var10000[var10[0] & 255];
            }

            if (i != 2) {
               if (i != 3) {
                  if (i == 4) {
                     outputstream.write((byte)(var4 << 2 & 252 | var5 >>> 4 & 3));
                     outputstream.write((byte)(var5 << 4 & 240 | var6 >>> 2 & 15));
                     outputstream.write((byte)(var6 << 6 & 192 | var7 & 63));
                  }
               } else {
                  outputstream.write((byte)(var4 << 2 & 252 | var5 >>> 4 & 3));
                  outputstream.write((byte)(var5 << 4 & 240 | var6 >>> 2 & 15));
               }
            } else {
               outputstream.write((byte)(var4 << 2 & 252 | var5 >>> 4 & 3));
            }

         }
      }
   }
}
